#include <cstdio>
#include <vector>
using namespace std;
#define MOD 1000003

static vector<int> zavorky;
static vector<int> casy;
static vector<int> suffixy;

static void
predpocitej_zavorkovani (int n)
{
  zavorky.resize (n + 1);
  zavorky[0] = 1;
  for (int z = 1; z <= n; z++)
    {
      long long s = 0;

      for (int a = 0; a < z; a++)
	s += (long long) zavorky[a] * zavorky[z - a - 1];

      zavorky[z] = s % MOD;
    }
}

int main (void)
{
  int n, m;
  scanf ("%d%d", &n, &m);
  casy.resize (2 * n);
  for (int i = 0; i < 2 * n; i++)
    scanf ("%d", &casy[i]);

  predpocitej_zavorkovani (n);
  suffixy.resize (n + 1);
  suffixy[n] = 1;
  
  for (int p = n - 1; p >= 0; p--)
    {
      long long s = 0;
      int cp = casy[2 * p];
      for (int a = 0; a + p < n; a++)
	{
	  if (casy[2 * (p + a) + 1] > cp + m)
	    break;
	  s += (long long) zavorky[a] * suffixy[p + a + 1];
	}

      suffixy[p] = s % MOD;
    }

  printf ("%d\n", suffixy[0]);
  return 0;
}
