#include <cstdio>
#include <vector>
using namespace std;
#define MOD 1000003

static int n, m;

static vector<int> casy;

static int
pocet_zavorkovani (int s, int delka)
{
  if (delka == 0)
    return 1;
  else if (delka == 2)
    {
      if (casy[s + 1] <= casy[s] + m)
	return 1;
      else
	return 0;
    }

  int mx = casy[s] + m;
  long long tot = 0;
  for (int df = 0; df < delka; df += 2)
    {
      if (casy[s + df + 1] > mx)
	break;

      tot += (long long) pocet_zavorkovani (s + 1, df) * pocet_zavorkovani (s + df + 2, delka - df - 2);
    }

  return tot % MOD;
}

int main (void)
{
  scanf ("%d%d", &n, &m);
  n *= 2;
  casy.resize (n);
  for (int i = 0; i < n; i++)
    scanf ("%d", &casy[i]);

  printf ("%d\n", pocet_zavorkovani (0, n));
  return 0;
}
