#include <cstdio>
#include <vector>
using namespace std;
#define MOD 1000003
#define MAXN 2000

static int n, m;
static int pocet[2 * MAXN][MAXN];

static vector<int> casy;

static int
pocet_zavorkovani (int s, int delka)
{
  if (delka == 0)
    return 1;
  else if (delka == 1)
    {
      if (casy[s + 1] <= casy[s] + m)
	return 1;
      else
	return 0;
    }

  if (pocet[s][delka])
    return pocet[s][delka] - 1; 

  int mx = casy[s] + m;
  long long tot = 0;
  for (int df = 0; df < delka; df++)
    {
      if (casy[s + 2 * df + 1] > mx)
	break;

      tot += (long long) pocet_zavorkovani (s + 1, df) * pocet_zavorkovani (s + 2 * df + 2, delka - df - 1);
    }

  int ret = tot % MOD;
  pocet[s][delka] = ret + 1;
  return ret;
}

int main (void)
{
  scanf ("%d%d", &n, &m);
  casy.resize (2 * n);
  for (int i = 0; i < 2 * n; i++)
    scanf ("%d", &casy[i]);

  printf ("%d\n", pocet_zavorkovani (0, n));
  return 0;
}
